import {EnvProperties} from "../app/openaireLibrary/utils/properties/env-properties";

export let properties: EnvProperties = {
  environment: "production",
  enablePiwikTrack: false,
  useCache: true,
  showContent: true,
  metricsAPIURL: "https://services.openaire.eu/usagestats/",
  framesAPIURL: "https://www.openaire.eu/stats3/",
  statisticsAPIURL: "https://services.openaire.eu/stats-api/",
  statisticsFrameAPIURL: "https://www.openaire.eu/stats/",
  statisticsFrameNewAPIURL: "",
  useNewStatistisTool: false,
  claimsAPIURL: "https://services.openaire.eu/claims/rest/claimsService/",
  searchAPIURLLAst: "https://services.openaire.eu/search/v2/api/",
  searchResourcesAPIURL: "https://services.openaire.eu/search/v2/api/resources",
  openCitationsAPIURL: "https://services.openaire.eu/opencitations/getCitations?id=",
  csvAPIURL: "https://services.openaire.eu/search/v2/api/reports",
  searchCrossrefAPIURL: "https://api.crossref.org/works",
  searchDataciteAPIURL: "https://api.datacite.org/works",
  searchOrcidURL: "https://pub.orcid.org/v2.1/",
  orcidURL: "https://orcid.org/",
  doiURL: "https://dx.doi.org/",
  cordisURL: "http://cordis.europa.eu/projects/",
  openDoarURL: "http://v2.sherpa.ac.uk/id/repository/",
  r3DataURL: "http://service.re3data.org/repository/",
  zenodo: "https://zenodo.org/",
  zenodoCommunities: "https://zenodo.org/api/communities/",
  openAccess: "https://www.openaire.eu/support/faq#article-id-234",
  openAccessRepo: "https://www.openaire.eu/support/faq#article-id-310",
  fp7Guidlines: "https://www.openaire.eu/open-access-in-fp7-seventh-research-framework-programme",
  h2020Guidlines: "https://www.openaire.eu/oa-publications/h2020/open-access-in-horizon-2020",
  ercGuidlines: "http://erc.europa.eu/sites/default/files/document/file/ERC_Open_Access_Guidelines-revised_2014.pdf",
  helpdesk: "https://www.openaire.eu/support/helpdesk",
  utilsService: "https://explore.openaire.eu/utils-service",
  
  vocabulariesAPI: "https://services.openaire.eu/provision/mvc/vocabularies/",
  
  piwikBaseUrl: "https://analytics.openaire.eu/piwik.php?idsite=",
  piwikSiteId: "112",
  loginUrl: "https://services.openaire.eu/_UPDATE_/openid_connect_login",
  
  logoutUrl: "https://aai.openaire.eu/proxy/saml2/idp/SingleLogoutService.php?ReturnTo=",
  
  cookieDomain: ".openaire.eu",
  
  feedbackmail: "feedback@openaire.eu",
  
  cacheUrl: "https://explore.openaire.eu/cache/get?url=",
  
  datasourcesAPI: "https://services.openaire.eu/openaire/ds/search/",
  
  monitorServiceAPIURL: "http://duffy.di.uoa.gr:8080/uoa-monitor-service",
  
  adminToolsAPIURL: "https://services.openaire.eu/uoa-admin-tools/",
  
  adminToolsCommunity: "connect",
  contextsAPI: "https://services.openaire.eu/openaire/context",
  
  communityAPI: "https://services.openaire.eu/openaire/community/",
  communitiesAPI: "https://services.openaire.eu/openaire/community/communities",
  
  csvLimit: 2000,
  pagingLimit: 20,
  resultsPerPage: 10,
  
  baseLink: "https://connect.openaire.eu",
  
  afterLoginRedirectLink: "/myCommunities",
  
  searchLinkToPublication: "/search/publication?articleId=",
  searchLinkToProject: "/search/project?projectId=",
  searchLinkToDataProvider: "/search/dataprovider?datasourceId=",
  searchLinkToDataset: "/search/dataset?datasetId=",
  searchLinkToSoftwareLanding: "/search/software?softwareId=",
  searchLinkToOrp: "/search/other?orpId=",
  searchLinkToOrganization: "/search/organization?organizationId=",
  
  searchLinkToPublications: "/search/find/publications",
  searchLinkToDataProviders: "/search/find/dataproviders",
  searchLinkToProjects: "/search/find/projects",
  searchLinkToDatasets: "/search/find/datasets",
  searchLinkToSoftware: "/search/find/software",
  searchLinkToOrps: "/search/find/other",
  searchLinkToOrganizations: "/search/find/organizations",
  searchLinkToCompatibleDataProviders: "/search/content-providers",
  searchLinkToEntityRegistriesDataProviders: "/search/entity-registries",
  searchLinkToEntityRegistriesDataProvidersTable: "/search/entity-registries-table",
  searchLinkToJournals: "/search/journals",
  searchLinkToJournalsTable: "/search/journals-table",
  
  searchLinkToAdvancedPublications: "/search/advanced/publications",
  searchLinkToAdvancedProjects: "/search/advanced/projects",
  searchLinkToAdvancedDatasets: "/search/advanced/datasets",
  searchLinkToAdvancedSoftware: "/search/advanced/software",
  searchLinkToAdvancedOrps: "/search/advanced/other",
  searchLinkToAdvancedDataProviders: "/search/advanced/dataproviders",
  searchLinkToAdvancedOrganizations: "/search/advanced/organizations",
  lastIndexInformationLink: "https://www.openaire.eu/aggregation-and-content-provision-workflows",
  showLastIndexInformationLink: true,
  widgetLink: "https://www.openaire.eu/index.php?option=com_openaire&view=widget&format=raw&projectId=",
  claimsInformationLink: "https://www.openaire.eu/linking",
  depositLearnHowPage: "/participate/deposit/learn-how",
  depositSearchPage: "/participate/deposit/search",
  shareInZenodoPage: "/participate/deposit/zenodo",
  reCaptchaSiteKey: "6LezhVIUAAAAAOb4nHDd87sckLhMXFDcHuKyS76P",
  
  admins: ["rcd-helpdesk@openaire.eu"],
  lastIndexUpdate: "2019-07-24",
  indexInfoAPI: "http://services.openaire.eu/openaire/info/"
}
